#!/usr/bin/env python

# -*- coding: utf-8 -*-
# (k) made-on-the-knee-of /dragon, 2017

import os,sys,logging,json
import time
from datetime import datetime, timedelta

from random import random
from binfs import *
from edgedb import *

log = logging.getLogger('Test binfspool')
log.setLevel(logging.DEBUG)
lh = logging.StreamHandler()
lh.setFormatter(logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s'))
log.addHandler(lh)
log.info("Begin")

btime = time.time()

p = binfspool(name="img",logger=log.getChild('POOL'))

p.setparam('minimum_space',149586437120)

cf = json.load(open('_pool.json'))

with open(cf['bin'], 'rb') as imagefile:
    image = imagefile.read()

rect = [0.111545, 0.653143, 0.177951, 0.673143]
e = EimageProcessor()

for n in ['frame','body','plate']:
    p.append(binfs(name=n,logger=log.getChild(n),root=os.path.join(cf['root'],n),oCreate=True))

if len(sys.argv) > 1:
    if sys.argv[1] == 'load':
        tstart = int((datetime.now() - datetime.fromtimestamp(0)).total_seconds() * 1e6)
        tdelta = int(120*1e6)
        tvar = 10000
        t = tstart
        for i in range(1000):
            r = p.byname('frame').save(t,image)
            print("F: %s -> %s" % (t,r))
            body = e.make(image,rect, 'body', {}, [])
            r = p.byname('body').save(t,body['data'])
            print("B: %s -> %s" % (t,r))
            p.byname('body').meta_set(t,json.dumps({k: v for k, v in body.iteritems() if not k == 'data'}))
            plate = e.make(image,rect, 'plate', {}, [])
            r = p.byname('plate').save(t,plate['data'])
            print("P: %s -> %s" % (t,r))
            p.byname('plate').meta_set(t,json.dumps({k: v for k, v in plate.iteritems() if not k == 'data'}))
            t = int(t - tdelta + tvar*random())
    elif sys.argv[1] == 'param':
        print(str(p.getparam('*')))
    elif sys.argv[1] == 'status':
        print(str(p.status()))
    elif sys.argv[1] == 'stat':
        for s in p:
            print(s.name+"\n----------------\n")
            print(json.dumps(s.stat,indent=4))
    elif sys.argv[1] == 'restat':    
        p.restat()
        print(str(p.stats()))
    elif sys.argv[1] == 'clean':
        r = p.cleanall()
        print("Clean: " + str(r))
        print(str(p.status()))
log.info("End")        
log.info("Elapsed time: %s" % (time.time()-btime))
