CREATE or replace FUNCTION core.const_init() RETURNS boolean AS $$
declare 
	r record;
begin

    if (_s('___const_text_inited') is null) then
        delete from const_text;
        insert into const_text(name, value) values
        ('CORE_DB_BUILT', now()::timestamp(6)::text),
        ('CORE_DB_ABOUT', null),
        ('ONE_BYTE_ENCODE','KOI8U'),
		('NOTIFY_OVERSEER_LISTEN_ON', 'LPR'),
		('PLATE_TRANSFORMATION','plate.cyr.latrus'),
		('_REVISIONS', '#unknown_revisions#'),

        ('___const_text_inited', '1');
    end if;

	if exists (select 1 from pg_tables where tablename = E'_const_preinstall') then
		for r in select * from public._const_preinstall loop
			if 		r.type = E'int' then
				if _i(r.key) notnull then
					update const_integer set value = r.value::integer where section = 'public' and name = r.key;
				else
					insert into const_integer(name, value) values (r.key, r.value::integer);
				end if;
			elsif 	r.type = E'text' then
				if _s(r.key) notnull then
					update const_text set value = r.value where section = 'public' and name = r.key;
				else
					insert into const_text(name, value) values (r.key, r.value);
				end if;
			end if;
		end loop;
		drop table _const_preinstall;
	end if;

    return true;
end;
$$ language plpgsql;

