
create table if not exists edge.plate_motions (
    ctime   timestamptz not null default now(),
    origin int not null,
    detector int not null,
    plate varchar(256) not null,
    during int8range,
    log jsonb,
    primary key (origin,detector,plate)
);
alter table edge.plate_motions alter column ctime  set storage plain;
alter table edge.plate_motions alter column origin set storage plain;
alter table edge.plate_motions alter column plate  set storage plain;

DO $$
BEGIN
IF to_regclass('i_plate_motions_origin') IS NULL THEN
    CREATE INDEX i_plate_motions_origin ON edge.plate_motions USING btree (origin);
END IF;
IF to_regclass('i_plate_motions_detector') IS NULL THEN
    CREATE INDEX i_plate_motions_detector ON edge.plate_motions USING btree (detector);
END IF;
IF to_regclass('i_plate_motions_ctime') IS NULL THEN
    CREATE INDEX i_plate_motions_ctime ON edge.plate_motions USING btree (ctime);
END IF;
IF to_regclass('i_plate_motions_during') IS NULL THEN
    CREATE INDEX i_plate_motions_during ON edge.plate_motions USING gist (during);
END IF;
END$$;

