create table if not exists hwp.watchlistlog (
    moment  timestamptz not null default now(),
    revision  varchar(32) not null,
    owner   varchar(32) not null,
    ident   varchar(32) not null,
    sha1    varchar(40),
    template varchar(32),
    inneraction varchar(32),
    crossaction varchar(32),
    outeraction varchar(32),
    description text,
    inserted integer not null default 0,
    updated integer not null default 0,
    deleted integer not null default 0
);

DO $$
BEGIN
    IF to_regclass('hwp.i_watchlistlog_ident') IS NULL THEN
        CREATE INDEX i_watchlistlog_ident ON hwp.watchlistlog USING btree (owner,ident);
    END IF;
    IF to_regclass('hwp.i_watchlistlog_time') IS NULL THEN
        CREATE INDEX i_watchlistlog_time ON hwp.watchlistlog USING btree (moment);
    END IF;
    IF to_regclass('hwp.i_watchlistlog_hash') IS NULL THEN
        CREATE INDEX i_watchlistlog_hash ON hwp.watchlistlog USING btree (sha1);
    END IF;
END $$;


