create table if not exists hwp.watchlistvcs (
    op      int not null default 0,
    optime  timestamptz not null default now(),
    revision varchar(32) not null, 
    sha1    varchar(40),
    owner   varchar(128) not null,
    ident   varchar(128) not null,
    plate   varchar(128) not null,
    class   varchar(128),
    color   varchar(128),
    make    varchar(128),
    model   varchar(218),
    alarm   varchar(32),
    memo    text,
    meta    json
);

DO $$
BEGIN
    IF to_regclass('hwp.i_watchlistvcs_ident') IS NULL THEN
        CREATE INDEX i_watchlistvcs_ident ON hwp.watchlistvcs USING btree (owner,ident);
    END IF;
    IF to_regclass('hwp.i_watchlistvcs_time') IS NULL THEN
        CREATE INDEX i_watchlistvcs_time ON hwp.watchlistvcs USING btree (optime);
    END IF;
    IF to_regclass('hwp.i_watchlistvcs_hash') IS NULL THEN
        CREATE INDEX i_watchlistvcs_hash ON hwp.watchlistvcs USING btree (sha1);
    END IF;
    IF to_regclass('hwp.i_watchlistvcs_revision') IS NULL THEN
        CREATE INDEX i_watchlistvcs_revision ON hwp.watchlistvcs USING btree (revision);
    END IF;
END $$;


