create or replace function public._estimatch( idata json, ipattern json, out ematch boolean, out elen integer ) as $$
import json, operator, re
pattern = json.loads(ipattern) if ipattern else dict()
data = json.loads(idata) if idata else dict()
elen = 0
ematch = True
operators = {
    'lt': operator.lt,
    '<' : operator.lt,
    'le': operator.le,
    '<=': operator.le,
    'eq': operator.eq,
    '==': operator.eq,
    'ne': operator.ne,
    '<>': operator.ne,
    'ge': operator.ge,
    '>=': operator.ge,
    'gt': operator.gt,
    '>' : operator.gt,
    '~' : re.match
}
for attr,body in pattern.iteritems():
    if type(body) <> list or len(body) <> 2:
        plpy.error('Invalid pattern body for ' + attr, hint='400')
    [op,val] = body
    if not op in operators:
        plpy.error('Invalid pattern body operator ' + op, hint='400')
    if attr in data:
        o = operators[op]
        if o.__module__ == 'operator':
            res = o(data[attr], val)
        elif o.__module__ == 're':
            res = o(val, data[attr]) is not  None
        else:
            res = False
        if res == True:
            elen += 1
        else:
            ematch = False
            break
    else:
        ematch = False
        break
return {"ematch": ematch, "elen": elen}    
$$ language plpythonu;

create or replace function public.estimate( iname varchar, idata json default null ) returns varchar as $$
    select 
        value 
    from 
        public.estimations,_estimatch($2,pattern) 
    where 
        name = $1 and ematch 
    order by elen desc limit 1;
$$ language sql immutable;

