CREATE TABLE if not exists notify_subscribers (
    recipient character varying(255) NOT NULL,
    passphrase character varying(32) NOT NULL,
    channel character varying(255) NOT NULL,
    timeout integer DEFAULT 0,
    enable boolean DEFAULT true NOT NULL
);


CREATE TABLE if not exists notify_messages (
    id bigserial primary key,
    moment timestamp with time zone DEFAULT now() NOT NULL,
    channel character varying(255),
    sender character varying(255),
    head character varying(255),
    body text
);


CREATE TABLE if not exists notify_stack (
    recipient character varying(255),
    channel character varying(32),
    messageid bigint NOT NULL
);

DO $$
BEGIN
IF to_regclass('public.i_notify_messages_channel') IS NULL THEN
    CREATE INDEX i_notify_messages_channel ON notify_messages USING btree (channel);
END IF;
IF to_regclass('public.i_notify_messages_moment') IS NULL THEN
    CREATE INDEX i_notify_messages_moment ON notify_messages USING btree (moment);
END IF;
END$$;
